unit FMain;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.StdCtrls,
  FMX.Objects, FMX.Controls.Presentation;


const
  NUMBER_PIEZAS = 1000;

type
  TArrPoints = Array[0..NUMBER_PIEZAS] of TPoint;

  TFormMain = class(TForm)
	Panel1: TPanel;
	Image1: TImage;
	Button4: TButton;
	Button5: TButton;
	Image2: TImage;
	Button1: TButton;
	procedure Button1Click(Sender: TObject);
	procedure Button2Click(Sender: TObject);
	procedure Button3Click(Sender: TObject);
	procedure Button4Click(Sender: TObject);
	procedure Button5Click(Sender: TObject);
	procedure Image1DblClick(Sender: TObject);
  private
  public
	procedure Update;
  end;

  TPaintThread = Class(TThread)
  private
	FCanvas: TCanvas;
	FNumberElements: integer;
	FMaxWidth: integer;
	FMaxHeight: integer;
	Brush:TStrokeBrush;
	FForm: TFormMain;
	ielems:Integer;
	function GetFill: TBrush;
  protected
	function GetRandomColor():TAlphaColor;
	function GetRamdomRect():TRectF;
	function GetRandomPoint():TPointF;
	property Fill:TBrush read GetFill;

	procedure UpdateCaption();
  public
	constructor Create(AForm:TFormMain; ACanvas:TCanvas; ANumberElements:integer; AMaxWidth, AMaxHeight:integer); reintroduce;
	destructor Destroy; override;
	
{
	property Canvas:TCanvas read FCanvas;
	property Form:TFormMain read FForm write FForm;

	property NumberElements:integer read FNumberElements write FNumberElements;
	property MaxWidth:integer read FMaxWidth write FMaxWidth;
	property MaxHeight:integer read FMaxHeight write FMaxHeight;
}	

	procedure Execute();override;
	procedure PaintElement(); virtual; abstract;
  end;

  TPaintLineThread = class(TPaintThread)
  public
	procedure PaintElement(); override;
  end;

  TPaintRectThread = class(TPaintThread)
  public
	procedure PaintElement(); override;
  end;

  TPaintEllipseThread = class(TPaintThread)
  public
	procedure PaintElement(); override;
  end;

var
  FormMain: TFormMain;


implementation

{$R *.fmx}
function GetRandomColor():TAlphaColor;
var
  col: TAlphaColorRec;
begin
  Randomize;
  col.R := Random(255);
  col.G := Random(255);
  col.B := Random(255);
  col.A := Random(255);
  Result := TAlphaColor(col);
end;

function GetRamdomRect():TRectF;
begin
  Randomize;
  Result.Left := Random(Trunc(FormMain.Image1.Bitmap.Width));
  Result.Top := Random(Trunc(FormMain.Image1.Bitmap.Height));
  Result.Right := Random(Trunc(FormMain.Image1.Bitmap.Width));
  Result.Bottom := Random(Trunc(FormMain.Image1.Bitmap.Height));
end;

function GetRandomPoint():TPointF;
begin
  Result.X := Random(Trunc(FormMain.Image1.Bitmap.Width));
  Result.Y := Random(Trunc(FormMain.Image1.Bitmap.Height));
end;


procedure TFormMain.Button1Click(Sender: TObject);
var
  i:integer;
  p1, p2:TPointF;
  lineBrush:TStrokeBrush;
begin
  Randomize;

  lineBrush := TStrokeBrush.Create(TBrushKind.Solid, TAlphaColor(0));
  linebrush.Kind := TBrushKind.Solid;
  try

	p1.x := Random(Trunc(Image1.Width));  p1.y := Random(Trunc(Image1.Height));
	p2.X := Random(Trunc(Image1.Width));  p2.y := Random(Trunc(Image1.Height));

	for i := 0 to NUMBER_PIEZAS do begin
	  lineBrush.Color := Random(100000);
	  lineBrush.Thickness := Random(5);

	  Image1.Bitmap.Canvas.Stroke.Color := Random(1000000);
	  Image1.Bitmap.Canvas.DrawLine(p1, p2, Random(100));
	  Image1.Bitmap.Canvas.DrawLine(p1, p2, Random(100), lineBrush);
	end;

  finally
	FreeAndNil(lineBrush);
  end;

end;

procedure TFormMain.Button2Click(Sender: TObject);
var
  brush:TStrokeBrush;
begin
  brush := TStrokeBrush.Create(TBrushKind.Solid, TAlphaColors.Black);
  brush.Thickness := 2;
  with Canvas do
  begin
	  BeginUpdate;
	  DrawLine(PointF(10, 10), PointF(100, 10), 1, brush);
	  EndUpdate;
  end;
end;

procedure TFormMain.Button3Click(Sender: TObject);
var
  Brush:TStrokeBrush;
begin
	with Canvas do
	begin
		BeginUpdate;
		Stroke.Color := TAlphaColors.Black;
		Stroke.Thickness := 2.0;
		DrawLine(PointF(10, 10), PointF(100, 10), 1);
		EndUpdate;
	end;

  Brush := TStrokeBrush.Create(TBrushKind.Solid, TAlphaColors.Black);
  Brush.Thickness := 2;
  with Canvas do
  begin
	BeginScene();
	DrawLine(PointF(10, 10), PointF(100, 10), 1, Brush);
	EndScene;
  end;

end;

procedure TFormMain.Button4Click(Sender: TObject);
var
  p1, p2:TPointF;
  pBrush:TStrokeBrush;
  pStroke:TBrush;
  i:integer;
  rect:TRectF;
begin
  // numeros aleatorios 
  Randomize;
  // Preparamos las caracteristicas del pintado
  pBrush := TStrokeBrush.Create(TBrushKind.Solid, GetRandomColor);
  pStroke := image1.Bitmap.Canvas.Fill;
  try
	pBrush.Dash := TStrokeDash.Solid;  // Otros
	pStroke.Kind := TBrushKind.Solid;
	//------------------------------------------------------------------
	for i := 0 to NUMBER_PIEZAS do begin
	  pBrush.Color := GetRandomColor;
	  pStroke.Color := GetRandomColor;
	  // RECTANGULO
	  rect := GetRamdomRect;
	  image1.Bitmap.Canvas.BeginScene;
	  try
		image1.Bitmap.Canvas.DrawRect(rect, Random(Trunc(rect.Width) DIV 2), Random(Trunc(rect.Height) DIV 2), [], Random(200), pBrush);
		image1.Bitmap.Canvas.FillRect(rect, Random(Trunc(rect.Width) DIV 2), Random(Trunc(rect.Height) DIV 2), [], Random(200), pBrush);
	  finally
		image1.Bitmap.Canvas.EndScene;
	  end;
	  Self.Caption := Format('Dibujados %d rectngulos',[i]);
	  Self.Update;
	end;
	//------------------------------------------------------------------
	for i := 0 to NUMBER_PIEZAS do begin
	  pBrush.Color := GetRandomColor;
	  pStroke.Color := GetRandomColor;
	  // ELIPSES
	  rect := GetRamdomRect;

	  image1.Bitmap.Canvas.BeginScene;
	  try
		image1.Bitmap.Canvas.DrawEllipse(rect, Random(200), pBrush);
		image1.Bitmap.Canvas.FillEllipse(rect, Random(200), pBrush);
	  finally
		image1.Bitmap.Canvas.EndScene;
	  end;
	  Self.Caption := Format('Dibujadas %d elipses',[i]);
	  Self.Update;
	end;
	//------------------------------------------------------------------
	for i := 0 to NUMBER_PIEZAS do begin
	  pBrush.Thickness := Random(4);
	  p1 := GetRandomPoint;
	  p2 := GetRandomPoint;
	  pBrush.Color := GetRandomColor;

	  image1.Bitmap.Canvas.BeginScene;
	  try
		// LINEA
		image1.Bitmap.Canvas.DrawLine(p1, p2, Random(200), pBrush);
	  finally
		image1.Bitmap.Canvas.EndScene;
	  end;
	  Self.Caption := Format('Dibujadas %d lineas',[i]);
	  Self.Update;
	end;
  finally
	FreeAndNil(pBrush);
  end;
end;



procedure TFormMain.Button5Click(Sender: TObject);
var
  th1:TPaintLineThread;
  th2:TPaintRectThread;
  th3:TPaintEllipseThread;
begin
  // Crear los threads
  th1 := TPaintLineThread.Create(Self, Image1.Bitmap.Canvas,
		  NUMBER_PIEZAS, Trunc(Image1.Bitmap.Width), Trunc(Image1.Bitmap.Height));
  th2 := TPaintRectThread.Create(Self, Image1.Bitmap.Canvas,
		  NUMBER_PIEZAS, Trunc(Image1.Bitmap.Width), Trunc(Image1.Bitmap.Height));
  th3 := TPaintEllipseThread.Create(Self, Image1.Bitmap.Canvas,
		  NUMBER_PIEZAS, Trunc(Image1.Bitmap.Width), Trunc(Image1.Bitmap.Height));

  th1.Resume;
  th2.Resume;
  th3.Resume;


end;


procedure TFormMain.Image1DblClick(Sender: TObject);
var
  rect:TRectF;
begin
  // Limpiar
  image1.Bitmap.Canvas.BeginScene;
  try
	// rect
	rect := TRectF.Create(0, 0, image1.Bitmap.Width, image1.Bitmap.Height);
	image1.Bitmap.Canvas.ClearRect(rect, TAlphaColorRec.white);
  finally
	image1.Bitmap.Canvas.EndScene;
  end;
end;


procedure TFormMain.Update;
begin
  Application.ProcessMessages;
end;


{ TPaintThread }
constructor TPaintThread.Create(AForm:TFormMain; ACanvas: TCanvas; ANumberElements:integer;
								AMaxWidth, AMaxHeight:integer);
begin
  inherited Create(False);
  FForm := AForm;
  FCanvas := ACanvas;
  FNumberElements := ANumberElements;
  FMaxWidth := AMaxWidth;
  FMaxHeight := AMaxHeight;

  Brush := TStrokeBrush.Create(TBrushKind.Solid, GetRandomColor);

end;

function TPaintThread.GetRandomColor():TAlphaColor;
var
  col: TAlphaColorRec;
begin
  Randomize;
  col.R := Random(255);
  col.G := Random(255);
  col.B := Random(255);
  col.A := Random(255);
  Result := TAlphaColor(col);
end;

function TPaintThread.GetRandomPoint: TPointF;
begin
  Result.X := Random(Trunc(MaxWidth));
  Result.Y := Random(Trunc(MaxHeight));
end;



procedure TPaintThread.UpdateCaption();
begin
  FForm.Caption := Format('Dibujadas %d lineas',[iElems]);
  Inc(iElems);
end;

function TPaintThread.GetFill: TBrush;
begin
  Result := FCanvas.Fill;
end;

function TPaintThread.GetRamdomRect():TRectF;
begin
  Randomize;
  Result.Left := Random(Trunc(MaxWidth));
  Result.Top := Random(Trunc(MaxHeight));
  Result.Right := Random(Trunc(MaxWidth));
  Result.Bottom := Random(Trunc(MaxHeight));
end;

destructor TPaintThread.Destroy;
begin
  FreeAndNil(Brush);
  inherited;
end;

procedure TPaintThread.Execute;
var
  i:Integer;
begin
  inherited;
  // Elementos dibujados
  iElems := 0;
  // Preparar las propiedades de pintado
  Brush.Dash := TStrokeDash.Solid;	// Otros
  brush.Color := 0;
  Fill.Kind := TBrushKind.Solid;
  Fill.Color := 0;
  // Lanzar la creacin de elementos
  for i := 0 to NumberElements do begin
	Fill.Color := GetRandomColor;
	Brush.Color := GetRandomColor;
	Brush.Thickness := Random(6);
	FCanvas.BeginScene;
	try
	  PaintElement;    // redefinido en las clases derivadas
	finally
	  FCanvas.EndScene;
	end;
	// Sincronizamos el caption del Form (NO el pintado)
	Synchronize(UpdateCaption);
  end;
end;

{ TPaintLineThread }

procedure TPaintLineThread.PaintElement;
var
  p1, p2:TPointF;
begin
  p1.x := Random(Trunc(FMaxWidth));
  p1.y := Random(Trunc(FMaxHeight));
  p2.x := Random(Trunc(FMaxWidth));
  p2.y := Random(Trunc(FMaxHeight));
  // LINEA
  FCanvas.DrawLine(p1, p2, Random(200), Brush);
end;

{ TPaintRectThread }

procedure TPaintRectThread.PaintElement;
var
  rect:TRectF;
begin
  rect := GetRamdomRect;
  // RECTANGULO
  FCanvas.DrawRect(rect, Random(Trunc(rect.Width) DIV 2), Random(Trunc(rect.Height) DIV 2), [], Random(200), Brush);
  FCanvas.FillRect(rect, Random(Trunc(rect.Width) DIV 2), Random(Trunc(rect.Height) DIV 2), [], Random(200), Brush);
end;

{ TPaintEllipseThread }

procedure TPaintEllipseThread.PaintElement;
var
  rect:TRectF;
begin
  rect := GetRamdomRect;
  // ELIPSES
  FCanvas.DrawEllipse(rect, Random(200), Brush);
  FCanvas.FillEllipse(rect, Random(200), Brush);
end;

end.
